import { DomManipulation, TemplateConfig } from "@rxweb/dom";
import { BaseDomProvider } from "../core/base-dom-provider";
import { ToastrDesignClass, ToastrConfig, ToastrHideConfig } from "./toastr-design-class";
import { ToastrMessageType } from "./toastr-message-type";
export declare abstract class Toastr extends BaseDomProvider {
    private rootElement;
    private domManipulations;
    designClass: ToastrDesignClass;
    defaultConfig: ToastrConfig;
    constructor();
    protected getDefaultTemplate(config: ToastrConfig, hideConfig: ToastrHideConfig): {
        div: {
            class: any[];
            childrens: {
                div: {
                    class: any[];
                    childrens: {
                        div: {
                            class: any[];
                            childrens: ({
                                button: {
                                    childrens: {
                                        text: {
                                            text: string;
                                        };
                                    }[];
                                    class: string[];
                                    event: {
                                        click: (event: any) => void;
                                    };
                                };
                                text?: undefined;
                            } | {
                                text: {
                                    text: string;
                                };
                                button?: undefined;
                            })[];
                        };
                    }[];
                };
            }[];
        };
    };
    private getMessage;
    show(message: string, messageType: ToastrMessageType, config?: ToastrConfig, customTemplate?: TemplateConfig): void;
    createRoot(): void;
    hide(domManipulation: DomManipulation, toastrConfig: ToastrConfig): void;
    private baseHide;
}
