import { DomManipulation, ElementConfig } from "@rxweb/dom";
export declare abstract class BaseDomProvider {
    protected elements: {
        [key: number]: DomManipulation;
    };
    createElement(parentElement: HTMLElement, elementName: string, elementConfig: ElementConfig, modelObject: Object, index: number, customEvents: {
        [key: string]: any;
    }): DomManipulation;
    private createChildElements;
    removeChildren(element: any, isRemoveRoot?: boolean): void;
}
