import { TemplateCategory } from "../enums/template-category";
import { TemplateConfig } from "@rxweb/dom";
import { ClassConfig } from "../interface/class-config";
export declare const controlsTemplateContainer: {
    get(templateCategory: TemplateCategory): {
        [key: string]: TemplateConfig;
    };
    addTemplate(templateCategory: TemplateCategory, customTemplates: {
        [key: string]: TemplateConfig;
    }, templateClass: ClassConfig): void;
    getClass(templateCategory: TemplateCategory): ClassConfig;
};
