import { TemplateConfig } from "@rxweb/dom";
import { BaseDomProvider } from "../core/base-dom-provider";
import { DialogClass } from "./dialog-class-config";
import { DialogViewMode } from "./dialog-view-mode";
import { DialogConfig } from "./dialog-config";
export declare abstract class Dialog extends BaseDomProvider {
    private domManipulation;
    private overLayElement;
    designClass: DialogClass;
    defaultConfig: DialogConfig;
    constructor();
    protected getDefaultTemplate(): TemplateConfig;
    show(message: string | DialogConfig, viewMode: DialogViewMode, template?: TemplateConfig): Promise<any>;
    protected getEvents(resolve: Function): {
        ok: () => any;
        cancel: () => any;
        save: () => any;
        dontsave: () => any;
    };
    hide(): void;
}
